//+------------------------------------------------------------------+
//|                        MultiZigZag                     MZZ9.mq4  |
//+------------------------------------------------------------------+
/*

  17  2014 .
  28  2015 .
  16  2015 .
  21  2015 .

  -  . 
       . 
  -   ,  -  ,  -  ,  -    ...  .

   ,    .   9 .
ParametresZZforDMLEWA -    ExtDepth  ExtBackstep
          0 -   
          1 - ExtDepth=5   ExtBackstep=8
          2 - ExtDepth=8   ExtBackstep=13
          3 - ExtDepth=13  ExtBackstep=21
          4 - ExtDepth=21  ExtBackstep=34
          5 - ExtDepth=34  ExtBackstep=55
          6 - ExtDepth=55  ExtBackstep=89
          7 - ExtDepth=89  ExtBackstep=144
          8 - ExtDepth=144 ExtBackstep=233

ExtDepth  ExtBackstep -    .
  ExtDepth=0,      .
ExtMaxBar -  ,    .
GrossPeriod -  ,   ,      .   0     .
zzVisible 0 -         , 1 -  .
zzStyle  zzWidth -         
zzColor  -     .
extColor -  ,       .

ExtProcedureOfPayments -   : true -    , false -   .

showZigZag -   . 0 -    . 1 -     . 2 -      , 
                ,     ,   DT-ZigZag

ExtReCalculate -   ,   0,     .      .

ExtComplect -   ,               
*/

#property link   "nen"

//      
//#property indicator_chart_window
#property indicator_separate_window
//    
#property indicator_buffers  8

//     
//extern string ExtDepth     = "12,0,0,0,0,0,0,0,0"; //  
/*
extern string ExtDepth     = "55,55,55,55,55,55,55,55,55";
extern string ExtBackstep  = "89,89,89,89,89,89,89,89,89";
*/
enum ZZforDMLEWA 
  {
   noDMLEWA=0, // 0: free select ExtDepth and ExtBackstep
   DMLEWA1=1,  // 1: ExtDepth=5   ExtBackstep=8
   DMLEWA2=2,  // 2: ExtDepth=8   ExtBackstep=13
   DMLEWA3=3,  // 3: ExtDepth=13  ExtBackstep=21
   DMLEWA4=4,  // 4: ExtDepth=21  ExtBackstep=34
   DMLEWA5=5,  // 5: ExtDepth=34  ExtBackstep=55
   DMLEWA6=6,  // 6: ExtDepth=55  ExtBackstep=89
   DMLEWA7=7,  // 7: ExtDepth=89  ExtBackstep=144
   DMLEWA8=8   // 8: ExtDepth=144 ExtBackstep=233
  };
input ZZforDMLEWA ParametresZZforDMLEWA   = DMLEWA6;

extern string ExtDepth     = "12,12,12,12,12,12,12,12,12";
extern string ExtBackstep  = "3,3,3,3,3,3,3,3,3";

extern string ExtMaxBar    = "1400,1400,1400,1400,1400,1400,1400,1400,1400,1400";    //    (0-)
extern string GrossPeriod  = "1,5,15,30,60,240,1440,10080,43200";     // ,    , 0 -  
extern int    externalBar  = 2; //   2 -    
extern string zzVisible    = "1,1,1,1,1,1,1,1,1";
extern string zzStyle      = "0,0,0,0,0,0,0,0,0";
extern string zzWidth      = "0,0,0,0,0,0,0,0,0";
extern string zzColor      = "clrTan,clrRoyalBlue,clrAqua,clrSaddleBrown,clrRed,clrYellow,clrMagenta,clrPurple,clrMediumSpringGreen";
extern string extColor     = "clrIndigo,clrOlive,clrTeal";

extern bool   ExtProcedureOfPayments = false;
extern int    showZigZag=0;
extern int    ExtReCalculate  = 3;              //     ,   0, 
                                                //    
extern int    ExtComplect  = 0;

int ExtDepth_[]={0,0,0,0,0,0,0,0,0}, ExtBackstep_[]={0,0,0,0,0,0,0,0,0}, ExtMaxBar_[]={0,0,0,0,0,0,0,0,0}, GrossPeriod_[]={0,0,0,0,0,0,0,0,0}, zzVisible_[]={0,0,0,0,0,0,0,0,0};
int zzColor_[]={0,0,0,0,0,0,0,0,0}, extColor_[]={0,0,0}, currentBars_[]={0,0,0,0,0,0,0,0,0}, zzStyle_[]={0,0,0,0,0,0,0,0,0}, zzWidth_[]={0,0,0,0,0,0,0,0,0};
//   
double LowestBuffer1[],HighestBuffer1[],LowestBuffer2[],HighestBuffer2[],LowestBuffer3[],HighestBuffer3[],LowestBuffer4[],HighestBuffer4[];
//   
double LowestBufferGross1[],HighestBufferGross1[],LowestBufferGross2[],HighestBufferGross2[],LowestBufferGross3[],HighestBufferGross3[],LowestBufferGross4[],HighestBufferGross4[];
double LowestBufferGross5[],HighestBufferGross5[],LowestBufferGross6[],HighestBufferGross6[],LowestBufferGross7[],HighestBufferGross7[],LowestBufferGross8[],HighestBufferGross8[];
double LowestBufferGross9[],HighestBufferGross9[];
//  , ,        
bool Grosstf_DT[]={false, false, false, false, false, false, false, false, false};
//  , ,     
bool ZZ_tf[]={false, false, false, false, false, false, false, false, false};
//        
datetime L2LTime[]={0,0,0,0,0,0,0,0,0},L2HTime[]={0,0,0,0,0,0,0,0,0};
//       lBar, hBar  tiZZ   
//             . 
//        .
double lBar[]={0,0,0,0,0,0,0,0,0}, hBar[]={0,0,0,0,0,0,0,0,0};
datetime tiZZ[]={0,0,0,0,0,0,0,0,0};
//      Bars
int saveBars[]={0,0,0,0,0,0,0,0,0};
int currentBars;
//      .     .
int ProcedureOfPayments[9][3];
//  ,   ,    
int limit;

//+------------------------------------------------------------------+
//| Initialization function. .                                 |
//+------------------------------------------------------------------+
int init()
  {
   int i,j,k,m,n,q;
   string str="", _Depth, _ExtBackstep;

//           
   SetIndexBuffer(0,LowestBuffer1);
   SetIndexBuffer(1,HighestBuffer1);
   SetIndexBuffer(2,LowestBuffer2);
   SetIndexBuffer(3,HighestBuffer2);
   SetIndexBuffer(4,LowestBuffer3);
   SetIndexBuffer(5,HighestBuffer3);
   SetIndexBuffer(6,LowestBuffer4);
   SetIndexBuffer(7,HighestBuffer4);

//   ,      
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);
   SetIndexEmptyValue(6,0.0);
   SetIndexEmptyValue(7,0.0);

   if (ParametresZZforDMLEWA>0)
     {
      switch (ParametresZZforDMLEWA)
        {
         case 1:
           _Depth="5,5,5,5,5,5,5,5,5"; _ExtBackstep="8,8,8,8,8,8,8,8,8";
           break;
         case 2:
           _Depth="8,8,8,8,8,8,8,8,8"; _ExtBackstep="13,13,13,13,13,13,13,13,13";
           break;
         case 3:
           _Depth="13,13,13,13,13,13,13,13,13"; _ExtBackstep="21,21,21,21,21,21,21,21,21";
           break;
         case 4:
           _Depth="21,21,21,21,21,21,21,21,21"; _ExtBackstep="34,34,34,34,34,34,34,34,34";
           break;
         case 5:
           _Depth="34,34,34,34,34,34,34,34,34"; _ExtBackstep="55,55,55,55,55,55,55,55,55";
           break;
         case 6:
           _Depth="55,55,55,55,55,55,55,55,55"; _ExtBackstep="89,89,89,89,89,89,89,89,89";
           break;
         case 7:
           _Depth="89,89,89,89,89,89,89,89,89"; _ExtBackstep="144,144,144,144,144,144,144,144,144";
           break;
         case 8:
           _Depth="144,144,144,144,144,144,144,144,144"; _ExtBackstep="233,233,233,233,233,233,233,233,233";
        }
     }
   else
     {
      _Depth=ExtDepth; _ExtBackstep=ExtBackstep;
     }

   _stringtointarray (_Depth,     ExtDepth_,       9);
   _stringtointarray (_ExtBackstep,  ExtBackstep_, 9);
   _stringtointarray (ExtMaxBar,    ExtMaxBar_,    9);
   _stringtointarray (GrossPeriod,  GrossPeriod_,  9);
   _stringtointarray (zzVisible,    zzVisible_,    9);
   _stringtocolorarray (zzColor,    zzColor_,      9);
   _stringtocolorarray (extColor,   extColor_,     3);
   _stringtointarray (zzStyle,  zzStyle_, 9);
   _stringtointarray (zzWidth,  zzWidth_, 9);

   for (i=0;i<9;i++)
     {
      Grosstf_DT[i]=false; ZZ_tf[i]=false;
      j=GrossPeriod_[i];
      GrossPeriod_[i]=_period(i,j);

      if (ExtDepth_[i]<=0) zzVisible_[i]=0;
      if (zzVisible_[i]>0)
        {
         m=ExtBackstep_[i]+ExtDepth_[i];
         if ((ExtMaxBar_[i]>iBars(NULL,GrossPeriod_[i])-m) || (ExtMaxBar_[i]==0)) limit=iBars(NULL,GrossPeriod_[i])- m; else limit=ExtMaxBar_[i];

         if (i==0) arr_resize(LowestBufferGross1, HighestBufferGross1, limit+m, i);
         else if (i==1) arr_resize(LowestBufferGross2, HighestBufferGross2, limit+m, i);
         else if (i==2) arr_resize(LowestBufferGross3, HighestBufferGross3, limit+m, i);
         else if (i==3) arr_resize(LowestBufferGross4, HighestBufferGross4, limit+m, i);
         else if (i==4) arr_resize(LowestBufferGross5, HighestBufferGross5, limit+m, i);
         else if (i==5) arr_resize(LowestBufferGross6, HighestBufferGross6, limit+m, i);
         else if (i==6) arr_resize(LowestBufferGross7, HighestBufferGross7, limit+m, i);
         else if (i==7) arr_resize(LowestBufferGross8, HighestBufferGross8, limit+m, i);
         else if (i==8) arr_resize(LowestBufferGross9, HighestBufferGross9, limit+m, i);
        }

      ProcedureOfPayments[i][0]=GrossPeriod_[i];
      ProcedureOfPayments[i][1]=i;
     }

   ArraySort(ProcedureOfPayments,WHOLE_ARRAY,0,MODE_ASCEND);

   if (showZigZag<0) showZigZag=0;
   if (showZigZag>2) showZigZag=2;

   j=1;k=0;q=-1;
   for (n=0;n<9;n++)
     {
      i=ProcedureOfPayments[n][1];
      if (zzVisible_[i]==0 || j>4) ProcedureOfPayments[n][2]=0;
      else if (GrossPeriod_[i]==0 || GrossPeriod_[i]>Period())
        {
         if (GrossPeriod_[i]==q)
           {
            zzColor_[i]=extColor_[k];
            k++;
           }

         q=GrossPeriod_[i];

         if (j==1)
           {
            if (showZigZag==0)
              {
               SetIndexStyle(0,DRAW_ZIGZAG, zzStyle_[i], zzWidth_[i], zzColor_[i]);
               SetIndexStyle(1,DRAW_ZIGZAG, zzStyle_[i], zzWidth_[i], zzColor_[i]);
              }
            else
              {
               SetIndexStyle(0,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(1,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               if (showZigZag==1)
                 {
                  SetIndexArrow(0, 116); 
                  SetIndexArrow(1, 116);
                 }
               else
                 {
                  SetIndexArrow(0, 159); 
                  SetIndexArrow(1, 159);
                 }
              }
           }
         else if (j==2)
           {
            if (showZigZag==0)
              {
               SetIndexStyle(2,DRAW_ZIGZAG, zzStyle_[i], zzWidth_[i], zzColor_[i]);
               SetIndexStyle(3,DRAW_ZIGZAG, zzStyle_[i], zzWidth_[i], zzColor_[i]);
              }
            else
              {
               SetIndexStyle(2,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(3,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               if (showZigZag==1)
                 {
                  SetIndexArrow(2, 116); 
                  SetIndexArrow(3, 116);
                 }
               else
                 {
                  SetIndexArrow(2, 159); 
                  SetIndexArrow(3, 159);
                 }
              }
           }
         else if (j==3)
           {
            if (showZigZag==0)
              {
               SetIndexStyle(4,DRAW_ZIGZAG, zzStyle_[i], zzWidth_[i], zzColor_[i]);
               SetIndexStyle(5,DRAW_ZIGZAG, zzStyle_[i], zzWidth_[i], zzColor_[i]);
              }
            else
              {
               SetIndexStyle(4,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(5,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               if (showZigZag==1)
                 {
                  SetIndexArrow(4, 116); 
                  SetIndexArrow(5, 116);
                 }
               else
                 {
                  SetIndexArrow(4, 159); 
                  SetIndexArrow(5, 159);
                 }
              }
           }
         else if (j==4)
           {
            if (showZigZag==0)
              {
               SetIndexStyle(6,DRAW_ZIGZAG, zzStyle_[i], zzWidth_[i], zzColor_[i]);
               SetIndexStyle(7,DRAW_ZIGZAG, zzStyle_[i], zzWidth_[i], zzColor_[i]);
              }
            else
              {
               SetIndexStyle(6,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(7,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               if (showZigZag==1)
                 {
                  SetIndexArrow(6, 116); 
                  SetIndexArrow(7, 116);
                 }
               else
                 {
                  SetIndexArrow(6, 159); 
                  SetIndexArrow(7, 159);
                 }
              }
           }
         ProcedureOfPayments[n][2]=j; j++;
        }
     }

   if (ExtProcedureOfPayments) ArraySort(ProcedureOfPayments,WHOLE_ARRAY,0,MODE_ASCEND); else ArraySort(ProcedureOfPayments,WHOLE_ARRAY,0,MODE_DESCEND);

//        
   for (n=0;n<9;n++)
     {
      if (GrossPeriod_[ProcedureOfPayments[n][1]]==0) str=""+Period(); else str=""+GrossPeriod_[ProcedureOfPayments[n][1]];
      if (ProcedureOfPayments[n][2]==1)
        {
         SetIndexLabel(0,"Low1_"+str );
         SetIndexLabel(1,"High1_"+str);
        }
      else if (ProcedureOfPayments[n][2]==2)
        {
         SetIndexLabel(2,"Low2_"+str );
         SetIndexLabel(3,"High2_"+str);
        }
      else if (ProcedureOfPayments[n][2]==3)
        {
         SetIndexLabel(4,"Low3_"+str );
         SetIndexLabel(5,"High3_"+str);
        }
      else if (ProcedureOfPayments[n][2]==4)
        {
         SetIndexLabel(6,"Low4_"+str );
         SetIndexLabel(7,"High4_"+str);
        }
     }

   currentBars=0;
//  

   return(0);
  }
//+------------------------------------------------------------------+
//| Initialization function. .                                  |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function. .              |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function. .               |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|  . .                                       |
//+------------------------------------------------------------------+
int start()
  {
   int i, m, n;
   bool calculate;

   if (Bars-currentBars>1)
     {
      for (n=0;n<9;n++)
        {
         if (ProcedureOfPayments[n][2]>0) {i=ProcedureOfPayments[n][1]; saveBars[i]=0; currentBars_[i]=0;}
        }
     }

   currentBars=Bars;

   for (n=0;n<9;n++)
     {
      i=ProcedureOfPayments[n][1];

      if (zzVisible_[i]==0) continue;

      if (iBars(NULL, GrossPeriod_[i])-currentBars_[i]>1) {saveBars[i]=0;}
      currentBars_[i]=iBars(NULL, GrossPeriod_[i]);

      m=ExtBackstep_[i]+ExtDepth_[i];
      if ((currentBars_[i]-1<m) || (m<=0)) continue;

      calculate=false;

      limit=iBars(NULL,GrossPeriod_[i])-saveBars[i]+1;

      if (limit>2)
        {
         calculate=true;
         Grosstf_DT[i]=false;
         ZZ_tf[i]=false;

         if ((ExtMaxBar_[i]>iBars(NULL,GrossPeriod_[i])-m) || (ExtMaxBar_[i]==0)) limit=iBars(NULL,GrossPeriod_[i])- m; else limit=ExtMaxBar_[i];

         if      (i==0) arr_resize(LowestBufferGross1, HighestBufferGross1, limit+m, i);
         else if (i==1) arr_resize(LowestBufferGross2, HighestBufferGross2, limit+m, i);
         else if (i==2) arr_resize(LowestBufferGross3, HighestBufferGross3, limit+m, i);
         else if (i==3) arr_resize(LowestBufferGross4, HighestBufferGross4, limit+m, i);
         else if (i==4) arr_resize(LowestBufferGross5, HighestBufferGross5, limit+m, i);
         else if (i==5) arr_resize(LowestBufferGross6, HighestBufferGross6, limit+m, i);
         else if (i==6) arr_resize(LowestBufferGross7, HighestBufferGross7, limit+m, i);
         else if (i==7) arr_resize(LowestBufferGross8, HighestBufferGross8, limit+m, i);
         else if (i==8) arr_resize(LowestBufferGross9, HighestBufferGross9, limit+m, i);

         if (ProcedureOfPayments[n][2]==1)
           {
            ArrayInitialize(LowestBuffer1,0); ArrayInitialize(HighestBuffer1,0);
           }
         else if (ProcedureOfPayments[n][2]==2)
           {
            ArrayInitialize(LowestBuffer2,0); ArrayInitialize(HighestBuffer2,0); 
           }
         else if (ProcedureOfPayments[n][2]==3)
           {
            ArrayInitialize(LowestBuffer3,0); ArrayInitialize(HighestBuffer3,0); 
           }
         else if (ProcedureOfPayments[n][2]==4)
           {
            ArrayInitialize(LowestBuffer4,0); ArrayInitialize(HighestBuffer4,0); 
           }

        }
      else
        {
         if (lBar[i]>iLow(NULL,GrossPeriod_[i],0) || hBar[i]<iHigh(NULL,GrossPeriod_[i],0) || tiZZ[i]!=iTime(NULL,GrossPeriod_[i],0))
           {
            calculate=true;
           }
        }

      if (calculate)
        {

         if      (i==0) _Gross(LowestBufferGross1, HighestBufferGross1, limit, n);
         else if (i==1) _Gross(LowestBufferGross2, HighestBufferGross2, limit, n);
         else if (i==2) _Gross(LowestBufferGross3, HighestBufferGross3, limit, n);
         else if (i==3) _Gross(LowestBufferGross4, HighestBufferGross4, limit, n);
         else if (i==4) _Gross(LowestBufferGross5, HighestBufferGross5, limit, n);
         else if (i==5) _Gross(LowestBufferGross6, HighestBufferGross6, limit, n);
         else if (i==6) _Gross(LowestBufferGross7, HighestBufferGross7, limit, n);
         else if (i==7) _Gross(LowestBufferGross8, HighestBufferGross8, limit, n);
         else if (i==8) _Gross(LowestBufferGross9, HighestBufferGross9, limit, n);

        }

     }

 //   
   return(0);
  }
//+------------------------------------------------------------------+
//|  . .                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|     Grossperiod. .                 |
//+------------------------------------------------------------------+

int _Gross(double& GLB[],double& GHB[],int limit_,int n)
  {
   int x=ProcedureOfPayments[n][1];

   if (GrossPeriod_[x]==0)
    {
     if      (ProcedureOfPayments[n][2]==1) ZigZag_(LowestBuffer1, HighestBuffer1, x);
     else if (ProcedureOfPayments[n][2]==2) ZigZag_(LowestBuffer2, HighestBuffer2, x);
     else if (ProcedureOfPayments[n][2]==3) ZigZag_(LowestBuffer3, HighestBuffer3, x);
     else if (ProcedureOfPayments[n][2]==4) ZigZag_(LowestBuffer4, HighestBuffer4, x);
     else
      {
       if (limit_==2) Shift_elements(GLB,GHB);
       ZigZag_(GLB, GHB, x);
      }
    }
   else
    {
     if (limit_==2) Shift_elements(GLB,GHB);
     if (ZigZag_(GLB, GHB, x)==0)
       {
        if      (ProcedureOfPayments[n][2]==1) ZigZagDT (LowestBuffer1, HighestBuffer1, GLB, GHB, x);
        else if (ProcedureOfPayments[n][2]==2) ZigZagDT (LowestBuffer2, HighestBuffer2, GLB, GHB, x);
        else if (ProcedureOfPayments[n][2]==3) ZigZagDT (LowestBuffer3, HighestBuffer3, GLB, GHB, x);
        else if (ProcedureOfPayments[n][2]==4) ZigZagDT (LowestBuffer4, HighestBuffer4, GLB, GHB, x);
       }
    }

   return(0);
  }
//+------------------------------------------------------------------+
//|     Grossperiod. .                  |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|   ZigZag. .                                        |
//+------------------------------------------------------------------+

int ZigZag_(double& LB[],double& HB[],int x)
  {
   int j, jl, jh, bar_l, bar_h, limit1;

   int    bar,back,lasthighpos=-1,lastlowpos=-1;
   double curlow,curhigh,lasthigh,lastlow,val;

   if (ZZ_tf[x]) //   .
     {
      //  ,    
      bar_l=iBarShift(NULL,GrossPeriod_[x],L2LTime[x],true);
      bar_h=iBarShift(NULL,GrossPeriod_[x],L2HTime[x],true);

      if ((bar_l<0) || (bar_h<0)) {saveBars[x]=0; return (-1);}
      if (L2LTime[x]<=L2HTime[x]) limit=bar_l; else limit=bar_h;

      limit1=limit-1;

      //  
      lastlow=iLow(NULL,GrossPeriod_[x],bar_l);
      lasthigh=iHigh(NULL,GrossPeriod_[x],bar_h);

     }
   else //    .
     {
      ZZ_tf[x]=true;
      bar_l=limit;
      bar_h=limit;

      limit1=limit;
     }

   //    
   for(bar=limit1; bar>=0; bar--)
     {
      //--- low
      if (bar<bar_l)
        {
         j=iLowest(NULL,GrossPeriod_[x],MODE_LOW,ExtDepth_[x],bar);

         if (j==bar)
           {
            val=iLow(NULL,GrossPeriod_[x],j);
            if(val==lastlow) val=0.0;
            else 
              { 
               lastlow=val; 
               for(back=1; back<=ExtBackstep_[x]; back++)
                 {
                  if(val<LB[j+back])LB[j+back]=0.0; 
                 }
              }

            LB[j]=val;
           } 
        }

      //--- high
      if (bar<bar_h)
        {
         j=iHighest(NULL,GrossPeriod_[x],MODE_HIGH,ExtDepth_[x],bar);

         if (j==bar)
           {
            val=iHigh(NULL,GrossPeriod_[x],j);
            if(val==lasthigh) val=0.0;
            else 
              {
               lasthigh=val;
               for(back=1; back<=ExtBackstep_[x]; back++)
                 {
                  if(val>HB[j+back])HB[j+back]=0.0; 
                 } 
              }

            if (j==bar) HB[j]=val;
           }
        }
     }
   //    

   //    .  
   lasthigh=-1; lastlow=-1;

   for(bar=limit; bar>=0; bar--)
     {
      curlow=LB[bar];
      curhigh=HB[bar];

      if((curlow==0)&&(curhigh==0)) continue;

      //   . 
      if(externalBar == 2 && curlow>0 && curhigh>0)
        {
         // externalBar = 0; //  2 -    

         int hl=ExternalBar(GrossPeriod_[x], bar);
         if (lasthigh<0 && lastlow<0)
           {
            if (hl<0)
              {
               lasthigh=curhigh;
               lasthighpos=bar;
              }
            else if (hl>0)
              {
               lastlow=curlow;
               lastlowpos=bar;
              }
           }
         else if (lasthigh>0)
           {
            if (hl>0)
              {
               if (lasthigh<curhigh) HB[lasthighpos]=0;
               else HB[bar]=0;
               lasthigh=-1;
               lastlow=curlow;
               lastlowpos=bar;
              }
            else if (hl<0)
              {
               lasthigh=curhigh;
               lasthighpos=bar;
              }
           }
         else if (lastlow>0)
           {
            if (hl<0)
              {
               if (lastlow>curlow) LB[lastlowpos]=0;
               else LB[bar]=0;
               lastlow=-1;
               lasthigh=curhigh;
               lasthighpos=bar;
              }
            else if (hl>0)
              {
               lastlow=curlow;
               lastlowpos=bar;
              }
           }
        } //   . 
      else
        {
         if(curhigh!=0)
           {
            if(lasthigh>0) 
              {
               if(lasthigh<curhigh) HB[lasthighpos]=0;
               else HB[bar]=0;
              }

            if((lasthigh<curhigh) || (lasthigh<0))
              {
               lasthigh=curhigh;
               lasthighpos=bar;
              }
            lastlow=-1;
           }

         if(curlow!=0)
           {
            if(lastlow>0)
              {
               if(lastlow>curlow) LB[lastlowpos]=0;
               else LB[bar]=0;
              }

            if((curlow<lastlow)||(lastlow<0))
              {
               lastlow=curlow;
               lastlowpos=bar;
              } 
            lasthigh=-1;
           }
        }
     } 
   //    

   //  
   saveBars[x]=iBars(NULL,GrossPeriod_[x]);
   lBar[x]=iLow(NULL,GrossPeriod_[x],0); hBar[x]=iHigh(NULL,GrossPeriod_[x],0); tiZZ[x]=iTime(NULL,GrossPeriod_[x],0);

   //          ,  
   jl=0;jh=0;
   for (bar=0;bar<saveBars[x];bar++)
     {
      if (LB[bar]>0) {if (jl<=1) {L2LTime[x]=iTime(NULL,GrossPeriod_[x],bar);} jl++;}
      if (HB[bar]>0) {if (jh<=1) {L2HTime[x]=iTime(NULL,GrossPeriod_[x],bar);} jh++;}
      if (jl>1 && jh>1) break;
     }

   return(0);
  }
//+------------------------------------------------------------------+
//|   ZigZag. .                                         |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|       . .|
//+------------------------------------------------------------------+
int ZigZagDT (double& LB[], double& HB[], double& LBG[], double& HBG[], int x)
  {
   int i=0, j, jl, jh, ext3=0, end, k;
   double el=-1, eh=-1;
   datetime t1, t2, t3=GrossPeriod_[x]*60-1;
   bool tdelta=false;

   if (Grosstf_DT[x]) //   .
     {
      end=ExtReCalculate+1;

      t1=iTime(NULL, GrossPeriod_[x],i);
      for (j=0;ext3<end && j<Bars;j++)
        {

         if (Period()==10080)
           {
            if (el<0 && eh<0) tdelta=Time[j]<t1;
            else tdelta=(Time[j]+t3)<t1;
           }
         else
           {
            tdelta=Time[j]<t1;
           }

         if (tdelta) {i++; if (showZigZag==2) {t2=t1+GrossPeriod_[x]*60;} t1=iTime(NULL, GrossPeriod_[x],i);}

         LB[j]=0;
         HB[j]=0;
         if (LBG[i]>0)
           {
            if (el>=Low[j] || el<0) {el=Low[j]; jl=j;}
           }
         else
           {
            if (el>0)
              {
               if (showZigZag==2)
                 {
                  for (k=j-1;Time[k]<t2;k--)
                    {
                     if (k<0) break;
                     LB[k]=el;
                    }
                 }

               LB[jl]=el; el=-1; ext3++;
              }
           }

         if  (HBG[i]>0)
           {
            if (eh<=High[j]) {eh=High[j]; jh=j;}
           }
         else
           {
            if (eh>0)
              {
               if (showZigZag==2)
                 {
                  for (k=j-1;Time[k]<t2;k--)
                    {
                     if (k<0) break;
                     HB[k]=eh;
                    }
                 }

               HB[jh]=eh; eh=-1; ext3++;
              }
           } 

        }
     }
   else //    .
     {
      if (limit<=ExtDepth_[x]+ExtBackstep_[x]) {saveBars[x]=0; return (-1);}
      end=iBarShift(NULL,Period(),iTime(NULL, GrossPeriod_[x],limit),false);

      if (end<=0) {saveBars[x]=0; return (-1);}

      Grosstf_DT[x]=true;

      t1=iTime(NULL, GrossPeriod_[x],i);
      for (j=0;j<end;j++)
        {

         if (Period()==10080)
           {
            if (el<0 && eh<0) tdelta=Time[j]<t1;
            else tdelta=Time[j]+t3<t1;
           }
         else
           {
            tdelta=Time[j]<t1;
           }

         if (tdelta) {i++; if (showZigZag==2) {t2=t1+GrossPeriod_[x]*60;} t1=iTime(NULL, GrossPeriod_[x],i);}

         if (LBG[i]>0)
           {
            if (el>=Low[j] || el<0) {el=Low[j]; jl=j;}
           }
         else
           {
            if (el>0)
              {
               if (showZigZag==2)
                 {
                  for (k=j-1;Time[k]<t2;k--)
                    {
                     if (k<0) break;
                     LB[k]=el;
                    }
                 }

               LB[jl]=el; el=-1;
              }
           }

         if  (HBG[i]>0)
           {
            if (eh<=High[j]) {eh=High[j]; jh=j;}
           }
         else
           {
            if (eh>0)
              {
               if (showZigZag==2)
                 {
                  for (k=j-1;Time[k]<t2;k--)
                    {
                     if (k<0) break;
                     HB[k]=eh;
                    }
                 }

               HB[jh]=eh; eh=-1;
              }
           } 
        }
     }

   return (0);
  }
//+------------------------------------------------------------------+
//|       . . |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|    . .                |
//+------------------------------------------------------------------+
int _period(int x, int tf)
  {
   if (tf<Period() && tf>0) ExtDepth_[x]=0;
   if (tf==Period()) return (0);
   return (tf);
  }
//+------------------------------------------------------------------+
//|    . .                 |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|     1  0      |
//| . .                                                 |
//+------------------------------------------------------------------+
void Shift_elements (double& arr[], double& arr1[])
  {
   int i,j;

   j=ArraySize(arr)-1;
   for (i=j;i>0;i--)
     {
      arr[i]=arr[i-1];
      arr1[i]=arr1[i-1];
     }
   arr[0]=0;
   arr1[0]=0;
  }
//-------------------------------------------------------------------+
//|     1  0      |
//| . .                                                  |
//-------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|         0|
//| .                                                          |
//+------------------------------------------------------------------+
void arr_resize (double& arr[], double& arr1[], int size, int x)
  {
   if (GrossPeriod_[x]>0)
     {
      ArrayResize(arr,size); ArrayResize(arr1,size);
      ArrayInitialize(arr,0); ArrayInitialize(arr1,0);
     }
  }
//+------------------------------------------------------------------+
//|         0|
//| .                                                           |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|        . . |
//+------------------------------------------------------------------+
void _stringtointarray (string str, int& arr[], int x)
  {
   int i,j,k=0;
   for (i=0;i<x;i++)
     {
      j=StringFind(str,",",k);
      if (j<0) {arr[i]=StrToInteger(StringSubstr(str,k)); break;}
      arr[i]=StrToInteger(StringSubstr(str,k,j-k));
      k=j+1;
     }
  }
//+------------------------------------------------------------------+
//|        ..   |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|        . . |
//+------------------------------------------------------------------+
void _stringtocolorarray (string str, int& arr[], int x)
  {
   int i,j,k=0;
   for (i=0;i<x;i++)
     {
      j=StringFind(str,",",k);
      if (j<0) {arr[i]=fStrToColor(StringSubstr(str,k)); break;}
      arr[i]=fStrToColor(StringSubstr(str,k,j-k));
      k=j+1;
     }
  }
//+------------------------------------------------------------------+
//|        ..   |
//+------------------------------------------------------------------+

//--------------------------------------------------------
//        . .
//--------------------------------------------------------
int ExternalBar(datetime _GrossPeriod, int shift)
  {
   datetime tf[]={PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,PERIOD_H1,PERIOD_H4,PERIOD_D1};
   int i, x, y=0, hl=0; // hl=-1 -     , hl=1 -  
   datetime mintime, maxtime, htime, ltime;
   double hext, lext, curhext, curlext, maxlow=1000000000;

   mintime=iTime(NULL,_GrossPeriod,shift);
   maxtime=mintime+_GrossPeriod*60;

   for (x=0; hl==0 && x<7 && tf[x]<_GrossPeriod; x++)
     {
      i=iBarShift(NULL,tf[x],mintime,false);

      if (iTime(NULL,tf[x],i)<maxtime)
        {
         hext=-1;
         lext=maxlow;
         htime=0;
         ltime=0;
         for (y=i; y>=0 && iTime(NULL,tf[x],y)<maxtime; y--)
           {
            if (iTime(NULL,tf[x],y)>=mintime)
              {
               curhext=iHigh(NULL,tf[x],y);
               curlext=iLow(NULL,tf[x],y);
               if (curhext>hext) {hext=curhext; htime=iTime(NULL,tf[x],y);}
               if (curlext<lext) {lext=curlext; ltime=iTime(NULL,tf[x],y);}
              }
           }
         if (htime>0 && ltime>0)
           {
            if (htime>ltime) hl=-1;
            if (htime<ltime) hl=1;
           }
        }
     }
   // hl=-1 -     , hl=1 -  , hl=0  
   return(hl);
  }
//--------------------------------------------------------
//        . .
//--------------------------------------------------------

//+------------------------------------------------------------------+
//|    . .                            |
//|   Integer.  http://forum.mql4.com/ru/7134          |
//+------------------------------------------------------------------+
color fStrToColor(string aName)
  {
 
   color tColor[]={  clrBlack, clrDarkGreen, clrDarkSlateGray, clrOlive, clrGreen, clrTeal, clrNavy, clrPurple, 
                     clrMaroon, clrIndigo, clrMidnightBlue, clrDarkBlue, clrDarkOliveGreen, clrSaddleBrown, 
                     clrForestGreen, clrOliveDrab, clrSeaGreen, clrDarkGoldenrod, clrDarkSlateBlue, 
                     clrSienna, clrMediumBlue, clrBrown, clrDarkTurquoise, clrDimGray, clrLightSeaGreen, 
                     clrDarkViolet, clrFireBrick, clrMediumVioletRed, clrMediumSeaGreen, clrChocolate, 
                     clrCrimson, clrSteelBlue, clrGoldenrod, clrMediumSpringGreen, clrLawnGreen, 
                     clrCadetBlue, clrDarkOrchid, clrYellowGreen, clrLimeGreen, clrOrangeRed, clrDarkOrange, 
                     clrOrange, clrGold, clrYellow, clrChartreuse, clrLime, clrSpringGreen, clrAqua, clrDeepSkyBlue, 
                     clrBlue, clrMagenta, clrRed, clrGray, clrSlateGray, clrPeru, clrBlueViolet, clrLightSlateGray, 
                     clrDeepPink, clrMediumTurquoise, clrDodgerBlue, clrTurquoise, clrRoyalBlue, clrSlateBlue, 
                     clrDarkKhaki, clrIndianRed, clrMediumOrchid, clrGreenYellow, clrMediumAquamarine, 
                     clrDarkSeaGreen, clrTomato, clrRosyBrown, clrOrchid, clrMediumPurple, clrPaleVioletRed, 
                     clrCoral, clrCornflowerBlue, clrDarkGray, clrSandyBrown, clrMediumSlateBlue, clrTan, 
                     clrDarkSalmon, clrBurlyWood, clrHotPink, clrSalmon, clrViolet, clrLightCoral, clrSkyBlue, 
                     clrLightSalmon, clrPlum, clrKhaki, clrLightGreen, clrAquamarine, clrSilver, clrLightSkyBlue, 
                     clrLightSteelBlue, clrLightBlue, clrPaleGreen, clrThistle, clrPowderBlue, clrPaleGoldenrod, 
                     clrPaleTurquoise, clrLightGray, clrWheat, clrNavajoWhite, clrMoccasin, clrLightPink, 
                     clrGainsboro, clrPeachPuff, clrPink, clrBisque, clrLightGoldenrod, clrBlanchedAlmond, 
                     clrLemonChiffon, clrBeige, clrAntiqueWhite, clrPapayaWhip, clrCornsilk, clrLightYellow, 
                     clrLightCyan, clrLinen, clrLavender, clrMistyRose, clrOldLace, clrWhiteSmoke, clrSeashell, 
                     clrIvory, clrHoneydew, clrAliceBlue, clrLavenderBlush, clrMintCream, clrSnow, clrWhite, clrNONE
                  };  
   string tName[]={  "clrBlack", "clrDarkGreen", "clrDarkSlateGray", "clrOlive", "clrGreen", "clrTeal", "clrNavy", "clrPurple", 
                     "clrMaroon", "clrIndigo", "clrMidnightBlue", "clrDarkBlue", "clrDarkOliveGreen", "clrSaddleBrown", 
                     "clrForestGreen", "clrOliveDrab", "clrSeaGreen", "clrDarkGoldenrod", "clrDarkSlateBlue", 
                     "clrSienna", "clrMediumBlue", "clrBrown", "clrDarkTurquoise", "clrDimGray", "clrLightSeaGreen", 
                     "clrDarkViolet", "clrFireBrick", "clrMediumVioletRed", "clrMediumSeaGreen", "clrChocolate", 
                     "clrCrimson", "clrSteelBlue", "clrGoldenrod", "clrMediumSpringGreen", "clrLawnGreen", 
                     "clrCadetBlue", "clrDarkOrchid", "clrYellowGreen", "clrLimeGreen", "clrOrangeRed", "clrDarkOrange", 
                     "clrOrange", "clrGold", "clrYellow", "clrChartreuse", "clrLime", "clrSpringGreen", "clrAqua", "clrDeepSkyBlue", 
                     "clrBlue", "clrMagenta", "clrRed", "clrGray", "clrSlateGray", "clrPeru", "clrBlueViolet", "clrLightSlateGray", 
                     "clrDeepPink", "clrMediumTurquoise", "clrDodgerBlue", "clrTurquoise", "clrRoyalBlue", "clrSlateBlue", 
                     "clrDarkKhaki", "clrIndianRed", "clrMediumOrchid", "clrGreenYellow", "clrMediumAquamarine", 
                     "clrDarkSeaGreen", "clrTomato", "clrRosyBrown", "clrOrchid", "clrMediumPurple", "clrPaleVioletRed", 
                     "clrCoral", "clrCornflowerBlue", "clrDarkGray", "clrSandyBrown", "clrMediumSlateBlue", "clrTan", 
                     "clrDarkSalmon", "clrBurlyWood", "clrHotPink", "clrSalmon", "clrViolet", "clrLightCoral", "clrSkyBlue", 
                     "clrLightSalmon", "clrPlum", "clrKhaki", "clrLightGreen", "clrAquamarine", "clrSilver", "clrLightSkyBlue", 
                     "clrLightSteelBlue", "clrLightBlue", "clrPaleGreen", "clrThistle", "clrPowderBlue", "clrPaleGoldenrod", 
                     "clrPaleTurquoise", "clrLightGray", "clrWheat", "clrNavajoWhite", "clrMoccasin", "clrLightPink", 
                     "clrGainsboro", "clrPeachPuff", "clrPink", "clrBisque", "clrLightGoldenrod", "clrBlanchedAlmond", 
                     "clrLemonChiffon", "clrBeige", "clrAntiqueWhite", "clrPapayaWhip", "clrCornsilk", "clrLightYellow", 
                     "clrLightCyan", "clrLinen", "clrLavender", "clrMistyRose", "clrOldLace", "clrWhiteSmoke", "clrSeashell", 
                     "clrIvory", "clrHoneydew", "clrAliceBlue", "clrLavenderBlush", "clrMintCream", "clrSnow", "clrWhite", "clrNONE"
                  };

   aName=StringTrimLeft(StringTrimRight(aName));      
   for(int i=0;i<ArraySize(tName);i++)
     {
      if(aName==tName[i])return(tColor[i]);
     }

  return(Red);                                     
 }
//+------------------------------------------------------------------+
//|    . .                             |
//|   Integer.  http://forum.mql4.com/ru/7134          |
//+------------------------------------------------------------------+

